<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>StereotypeApplicationPopupEditorConfigurationContribution xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contributions/StereotypeApplicationPopupEditorConfigurationContribution.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2010, 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  CEA LIST - Initial API and implementation</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.ui.contributions;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionException;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IAdaptable;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.TransactionalEditingDomain;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.common.core.command.CommandResult;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.common.core.command.ICommand;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.common.core.command.UnexecutableCommand;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.extensionpoints.editors.configuration.ICustomDirectEditorConfiguration;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.emf.utils.EMFHelper;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.ExpressionValueRule;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.StereotypeApplicationRule;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.StereotypeApplicationsRule;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.stereotypeApplicationWithVSL.TagSpecificationRule;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.textedit.stereotypeapplicationwithvsl.xtext.ui.internal.StereotypeApplicationWithVSLActivator;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.extensions.VSLSerializationUtil;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.ui.contentassist.VSLProposalUtils;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.CollectionOrTuple;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.Expression;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.vSL.NameOrChoiceOrBehaviorCall;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.marte.vsl.validation.VSLJavaValidator;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.xtext.integration.DefaultXtextDirectEditorConfiguration;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EnumerationLiteral;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <strong class="jxr_keyword">import</strong> com.google.inject.Injector;
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment"> * @author CEA LIST</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contributions/StereotypeApplicationPopupEditorConfigurationContribution.html">StereotypeApplicationPopupEditorConfigurationContribution</a> <strong class="jxr_keyword">extends</strong> DefaultXtextDirectEditorConfiguration <strong class="jxr_keyword">implements</strong> ICustomDirectEditorConfiguration {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_comment">	 * @see org.eclipse.papyrus.infra.gmfdiag.xtext.glue.PopupEditorConfiguration#getTextToEdit(java.lang.Object)</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	@Override
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<strong class="jxr_keyword">public</strong> String getTextToEdit(Object editedObject) {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		<strong class="jxr_keyword">if</strong> (editedObject instanceof Element) {
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			Element stereotypedElement = (Element) editedObject;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			String textToEdit = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			<strong class="jxr_keyword">for</strong> (Stereotype stereotype : stereotypedElement.getAppliedStereotypes()) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  				textToEdit += <span class="jxr_string">"&lt;&lt;"</span> + stereotype.getName() + <span class="jxr_string">"&gt;&gt;"</span>;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				<strong class="jxr_keyword">boolean</strong> first = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				<strong class="jxr_keyword">for</strong> (Property p : stereotype.getAllAttributes()) {
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  					<strong class="jxr_keyword">if</strong> (!(p.getName().startsWith(<span class="jxr_string">"base_"</span>) || p.isDerived())) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  						Object value = stereotypedElement.getValue(stereotype, p.getName());
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  						<strong class="jxr_keyword">if</strong> (value instanceof EnumerationLiteral) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  							<strong class="jxr_keyword">if</strong> (p.getType() instanceof Stereotype || p.getType() instanceof org.eclipse.uml2.uml.Class) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  								value = VSLProposalUtils.getNameLabel((NamedElement) value);
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  								value = ((NamedElement) value).getName();
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  							}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  						} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (value instanceof NamedElement) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  							value = VSLProposalUtils.getNameLabel((NamedElement) value);
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  						} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (value instanceof EObject) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  							Element stereoElement = UMLUtil.getBaseElement((EObject) value);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  							<strong class="jxr_keyword">if</strong> (stereoElement != <strong class="jxr_keyword">null</strong> &amp;&amp; stereoElement instanceof NamedElement) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  								value = VSLProposalUtils.getNameLabel(((NamedElement) stereoElement));
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  								<em class="jxr_comment">// TODO ... Compute a label in case of Element without Name</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  								value = <span class="jxr_string">"/* The referenced element is not a named element. You should edit this stereotype with the property view */"</span>;
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  							}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  						} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (value instanceof String) {
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  							<strong class="jxr_keyword">if</strong> ((p.getType() instanceof PrimitiveType) &amp;&amp; (p.getType().getName().equals(<span class="jxr_string">"String"</span>))) {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  								<em class="jxr_comment">// quote strings</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  								value = <span class="jxr_string">"\&quot;"</span> + value + <span class="jxr_string">"\&quot;"</span>;
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  							}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 						}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 						<strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong> &amp;&amp; value instanceof List) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 							List listOfValues = (List) value;
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 							<strong class="jxr_keyword">if</strong> (!listOfValues.isEmpty()) {
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 								String collString = <span class="jxr_string">"{"</span>;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 								<strong class="jxr_keyword">boolean</strong> nestedFirst = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 								<strong class="jxr_keyword">for</strong> (Object o : listOfValues) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 									<strong class="jxr_keyword">if</strong> (!nestedFirst) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 										collString += <span class="jxr_string">", "</span>;
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 									} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 										nestedFirst = false;
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 									}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 									<strong class="jxr_keyword">if</strong> (o instanceof EnumerationLiteral) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 										<strong class="jxr_keyword">if</strong> (p.getType() instanceof Stereotype || p.getType() instanceof org.eclipse.uml2.uml.Class) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 											value = VSLProposalUtils.getNameLabel((NamedElement) value);
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 										} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 											value = ((NamedElement) value).getName();
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 										}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 									} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (o instanceof NamedElement) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 										collString += VSLProposalUtils.getNameLabel((NamedElement) o);
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 									} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (o instanceof EObject) {
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 										Element stereoElement = UMLUtil.getBaseElement((EObject) o);
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 										<strong class="jxr_keyword">if</strong> (stereoElement != <strong class="jxr_keyword">null</strong> &amp;&amp; stereoElement instanceof NamedElement) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 											collString += VSLProposalUtils.getNameLabel((NamedElement) stereoElement);
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 										} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 											<em class="jxr_comment">// TODO ... Compute a label in case of Element without Name</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 											collString += <span class="jxr_string">"/* The referenced element is not a named element. You should edit this stereotype with the property view */"</span>;
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 										}
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 									} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 										<em class="jxr_comment">// o is a string</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 										collString += o;
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 									}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 								}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 								collString += <span class="jxr_string">"}"</span>;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 								<strong class="jxr_keyword">if</strong> (first) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 									textToEdit += <span class="jxr_string">"\n"</span>;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 									first = false;
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 								} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 									textToEdit += <span class="jxr_string">",\n"</span>;
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 								}
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 								textToEdit += p.getName() + <span class="jxr_string">" = "</span> + collString;
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 							}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 						} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 							<strong class="jxr_keyword">if</strong> (first) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 								textToEdit += <span class="jxr_string">"\n"</span>;
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 								first = false;
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 							} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 								textToEdit += <span class="jxr_string">",\n"</span>;
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 							}
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 							textToEdit += p.getName() + <span class="jxr_string">" = "</span> + value;
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 						}
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 					}
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 				}
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				textToEdit += <span class="jxr_string">"\n\n"</span>;
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			<strong class="jxr_keyword">return</strong> textToEdit;
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		}
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		<strong class="jxr_keyword">return</strong> <span class="jxr_string">"// not an Element"</span>;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 * @author CEA LIST</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 *         A command for updating the context UML model</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contributions/StereotypeApplicationPopupEditorConfigurationContribution.html">UpdateStereotypeApplicationsCommand</a> <strong class="jxr_keyword">extends</strong> AbstractTransactionalCommand {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 		<strong class="jxr_keyword">private</strong> Element stereotypedElement;
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		<strong class="jxr_keyword">private</strong> StereotypeApplicationsRule stereotypeApplicationsObject;
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_comment">		 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_comment">		 *</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_comment">		 * @see</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_comment">		 * org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand#doExecuteWithResult(org.eclipse.core.runtime.IProgressMonitor</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_comment">		 * , org.eclipse.core.runtime.IAdaptable)</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 		@Override
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 		<strong class="jxr_keyword">protected</strong> CommandResult doExecuteWithResult(IProgressMonitor arg0, IAdaptable arg1) <strong class="jxr_keyword">throws</strong> ExecutionException {
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 			<em class="jxr_comment">// //////////////////////////////////////////////////////////</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 			<em class="jxr_comment">// First delete any stereotype application associated with the stereotyped element</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 			<em class="jxr_comment">// //////////////////////////////////////////////////////////</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			List&lt;Stereotype&gt; appliedStereotypes = stereotypedElement.getAppliedStereotypes();
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 			<strong class="jxr_keyword">for</strong> (Stereotype s : appliedStereotypes) {
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 				stereotypedElement.unapplyStereotype(s);
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			}
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			<em class="jxr_comment">// ////////////////////////////////////////////////////////////////////////////////////////////////</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			<em class="jxr_comment">// Then extract any relevant information from the StereotypeApplicationRules object, and update the stereotypedElement</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 			<em class="jxr_comment">// ////////////////////////////////////////////////////////////////////////////////////////////////</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			<strong class="jxr_keyword">for</strong> (StereotypeApplicationRule sApp : stereotypeApplicationsObject.getStereotypeApplications()) {
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 				Stereotype stereotype = sApp.getStereotype();
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 				stereotypedElement.applyStereotype(stereotype);
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 				<strong class="jxr_keyword">for</strong> (TagSpecificationRule tag : sApp.getTagSpecification()) {
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 					Property property = tag.getProperty();
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 					Type type = property.getType();
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 					ExpressionValueRule value = tag.getValue();
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 					Object valueRepresentation = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 					<em class="jxr_comment">// TODO shouldStoreObjectsAndNotStrings is not enough. Should have a specific boolean for the case of stereotype applications</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 					<strong class="jxr_keyword">boolean</strong> shouldStoreObjectsAndNotStrings = (type instanceof Stereotype || type instanceof org.eclipse.uml2.uml.Class);
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 					<strong class="jxr_keyword">boolean</strong> propertyIsACollection = VSLJavaValidator.isACollection(value.getExpression()) != <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 					<strong class="jxr_keyword">if</strong> (!propertyIsACollection) {
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 						<strong class="jxr_keyword">if</strong> (!shouldStoreObjectsAndNotStrings) {
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 							valueRepresentation = VSLSerializationUtil.printExpression(value.getExpression());
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 							<strong class="jxr_keyword">if</strong> ((type instanceof PrimitiveType) &amp;&amp; (type.getName().equals(<span class="jxr_string">"String"</span>)) &amp;&amp; (valueRepresentation instanceof String)) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 								<em class="jxr_comment">// unquote Strings, remove 1st and last character</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 								String stringValue = (String) valueRepresentation;
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 								<strong class="jxr_keyword">if</strong> (stringValue.length() &gt; 2) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 									valueRepresentation = stringValue.substring(1, stringValue.length() - 1);
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 								} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 									valueRepresentation = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 								}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 							}
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 						} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 							NameOrChoiceOrBehaviorCall nameRule = VSLSerializationUtil.extractNameReference(value.getExpression());
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 							<strong class="jxr_keyword">if</strong> (nameRule != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 								<strong class="jxr_keyword">if</strong> (!(property.getType() instanceof Stereotype)) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 									valueRepresentation = nameRule.getId();
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 								} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 									valueRepresentation = nameRule.getId().getStereotypeApplication(((Stereotype) property.getType()));
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 								}
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 							}
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 							<em class="jxr_comment">// TODO: specific case of stereotype applications</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 						}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 					} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 						<em class="jxr_comment">// the property has an upper bound &gt; 1</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 						<strong class="jxr_keyword">if</strong> (!shouldStoreObjectsAndNotStrings) {
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 							List&lt;String&gt; listOfValues = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 							CollectionOrTuple collection = VSLJavaValidator.isACollection(value.getExpression());
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 							<strong class="jxr_keyword">for</strong> (Expression e : collection.getListOfValues().getValues()) {
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 								listOfValues.add(VSLSerializationUtil.printExpression(e));
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 							}
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 							valueRepresentation = listOfValues;
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 						} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 							List&lt;Object&gt; listOfValues = <strong class="jxr_keyword">new</strong> ArrayList&lt;Object&gt;();
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 							CollectionOrTuple collection = VSLJavaValidator.isACollection(value.getExpression());
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 							<strong class="jxr_keyword">for</strong> (Expression e : collection.getListOfValues().getValues()) {
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 								NameOrChoiceOrBehaviorCall nameRule = VSLSerializationUtil.extractNameReference(e);
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 								<strong class="jxr_keyword">if</strong> (nameRule != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 									<strong class="jxr_keyword">if</strong> (!(property.getType() instanceof Stereotype)) {
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 										listOfValues.add(nameRule.getId());
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 									} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 										listOfValues.add(nameRule.getId().getStereotypeApplication(((Stereotype) property.getType())));
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 									}
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 								}
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 								<em class="jxr_comment">// TODO: specific case of stereotype applications</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 							}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 							valueRepresentation = listOfValues;
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 						}
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 					}
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 					stereotypedElement.setValue(stereotype, property.getName(), valueRepresentation);
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 				}
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 			}
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 			<strong class="jxr_keyword">return</strong> CommandResult.newOKCommandResult(stereotypedElement);
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		}
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contributions/StereotypeApplicationPopupEditorConfigurationContribution.html">UpdateStereotypeApplicationsCommand</a>(Element stereotypedElement, StereotypeApplicationsRule stereotypeApplicationsObject) {
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 			<strong class="jxr_keyword">super</strong>((TransactionalEditingDomain) EMFHelper.resolveEditingDomain(stereotypedElement), <span class="jxr_string">"Stereotype Applications Update"</span>, getWorkspaceFiles(stereotypedElement));
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 			<strong class="jxr_keyword">this</strong>.stereotypedElement = stereotypedElement;
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 			<strong class="jxr_keyword">this</strong>.stereotypeApplicationsObject = stereotypeApplicationsObject;
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 		}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 	}
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	@Override
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 	<strong class="jxr_keyword">public</strong> Injector getInjector() {
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 		<strong class="jxr_keyword">return</strong> StereotypeApplicationWithVSLActivator.getInstance().getInjector(StereotypeApplicationWithVSLActivator.ORG_ECLIPSE_PAPYRUS_MARTE_TEXTEDIT_STEREOTYPEAPPLICATIONWITHVSL_XTEXT_STEREOTYPEAPPLICATIONWITHVSL);
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 	}
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 	@Override
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 	<strong class="jxr_keyword">protected</strong> ICommand getParseCommand(EObject modelObject, EObject xtextObject) {
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 		<em class="jxr_comment">// first: retrieves / determines if the xtextObject is a TransitionRule object</em>
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		EObject modifiedObject = xtextObject;
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 		<strong class="jxr_keyword">if</strong> (!(modelObject instanceof Element)) {
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 			<strong class="jxr_keyword">return</strong> UnexecutableCommand.INSTANCE;
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 		}
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		<strong class="jxr_keyword">while</strong> (xtextObject != <strong class="jxr_keyword">null</strong> &amp;&amp; !(xtextObject instanceof StereotypeApplicationsRule)) {
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 			modifiedObject = modifiedObject.eContainer();
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 		}
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 		<strong class="jxr_keyword">if</strong> (modifiedObject == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 			<strong class="jxr_keyword">return</strong> UnexecutableCommand.INSTANCE;
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 		}
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 		Element stereotypedElement = (Element) modelObject;
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 		StereotypeApplicationsRule stereotypeApplicationsObject = (StereotypeApplicationsRule) xtextObject;
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 		<em class="jxr_comment">// Creates and executes the update command</em>
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 		UpdateStereotypeApplicationsCommand updateCommand = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/marte/textedit/stereotypeapplicationwithvsl/xtext/ui/contributions/StereotypeApplicationPopupEditorConfigurationContribution.html">UpdateStereotypeApplicationsCommand</a>(stereotypedElement, stereotypeApplicationsObject);
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 		<strong class="jxr_keyword">return</strong> updateCommand;
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 	}
<a class="jxr_linenumber" name="L301" href="#L301">301</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
